/* hanoi.pl */

hanoi(H) :- nl,
            write('Turm von Hanoi'), 
            nl,
            write('bringe '),
            write(H), 
            write(' Scheiben von a nach c via b '),
            nl, nl,
            hanoi(a,c,b,H), !, true.

hanoi(S,D,M,H) :- xhanoi(S,D,M,H,H).


xhanoi(S,D,_,1,I) :- write('scheibe  '),
                     write(I),
                     write('  von  '),
                     write(S),
                     write('  nach  '),
                     write(D),
                     nl.

xhanoi(S,D,M,H,I) :- H1 is H - 1,
                     xhanoi(S,M,D,H1,H1),
                     xhanoi(S,D,M,1,I),
                     xhanoi(M,D,S,H1,H1).
